#!---------------------------------------------------------------- 
#Template(ShuffleLeg,'Shuffle Browsed Records')
#EXTENSION(ShuffleRecordsLeg,'Shuffle Browsed Records Legacy'),WINDOW,MULTI
#SHEET
    #TAB('Required')
        #DISPLAY('')
        #PROMPT('BROWSE FILE NAME:', FILE),%TheFile
        #DISPLAY('')
        #PROMPT('BROWSE LIST KEY:',  KEY(%TheFile)),%TheKey
        #DISPLAY('')
        #PROMPT('KEY COMPONENT:',COMPONENT(%TheKey)),%TheField
        #DISPLAY('')
        #DISPLAY('(Must be the first free key element)')
        #DISPLAY('')
        #PROMPT('CONDITION:',@S255),%Condition, AT(60,,124,10)
        #DISPLAY('')
        #DISPLAY('(Optional to conditionally enable/disable template.')
        #DISPLAY('Leave it blank to have it always enabled)')
    #ENDTAB
    #TAB('Defaults')
        #PROMPT('USE:',CONTROL),%BrowseUse,DEFAULT('?Browse:1')
        #DISPLAY('')
        #DISPLAY('(List Property => General => Use:)')
        #DISPLAY('')
        #PROMPT('FROM:', @s20),%BrowseFrom,DEFAULT('Queue:Browse:1')
        #DISPLAY('')
        #DISPLAY('(List Property => General => From:)')
        #DISPLAY('')
        #PROMPT('BROWSE IDENTIFIER:', @s20),%BrowseObject,DEFAULT('BRW1')
        #DISPLAY('')
        #DISPLAY('(Can be found from procedure source.')
        #DISPLAY('Look for BRW1, BRW2 etc)')
        #DISPLAY('')
    #ENDTAB
    #TAB('Help')
        #DISPLAY('The template can be successfully used only where')
        #DISPLAY('browse box''s first free key element is numeric')
        #DISPLAY('(it defines order of records in the browse)')
        #DISPLAY('If you have multi-tab browse you may enable template')
        #DISPLAY('on one tab only. Put into Condition prompt (Tab 1)')
        #DISPLAY('something like: CHOICE(?CurrentTab) = 2')
        #DISPLAY('')
        #DISPLAY('INSTRACTION:')
        #DISPLAY('')
        #DISPLAY('1. Open List Property => Extra and put the same')
        #DISPLAY('    identifier into DragID and DropID (say, DragDrop)')
        #DISPLAY('2. On Tab 1 Specify File name, Key and Field')
        #DISPLAY('3. Only if you have changed default Clarion')
        #DISPLAY('    names or the Browse box is not first,')
        #DISPLAY('    go to Tab 2 and enter new names')
        #DISPLAY('4. Now you should be able to Drag and Drop')
        #DISPLAY('    records to change their order in the Browse ')
        #DISPLAY('')
        #DISPLAY('     Copyright C 2000, Vivid Help Systems Pty Ltd')
    #ENDTAB
#ENDSHEET
#AT (%DataSectionBeforeWindow)
tpl:BigLONG:%ActiveTemplateInstance             LONG(10000000)
tpl:FromSysID:%ActiveTemplateInstance            LONG
tpl:ToSysID:%ActiveTemplateInstance              LONG
tpl:Delta:%ActiveTemplateInstance                LONG
tpl:FromQueuePosit:%ActiveTemplateInstance       LONG
tpl:ToQueuePosit:%ActiveTemplateInstance         LONG
tpl:TempSysID:%ActiveTemplateInstance            LONG
tpl:Identifier:%ActiveTemplateInstance           STRING('TplDragDrop {9}')
#ENDAT
#AT(%ControlEventHandling,%BrowseUse,'Drag'), PRIORITY(4000)
    tpl:FromQueuePosit:%ActiveTemplateInstance = %BrowseUse{PROPLIST:MouseDownRow}
#ENDAT
#AT(%ControlEventHandling,%BrowseUse,'Drop'), PRIORITY(4000)
DO SyncWindow
tpl:ToQueuePosit:%ActiveTemplateInstance = %BrowseUse{PROPLIST:MouseUpRow}

IF tpl:ToQueuePosit:%ActiveTemplateInstance = 0 THEN tpl:ToQueuePosit:%ActiveTemplateInstance = 1.
IF tpl:ToQueuePosit:%ActiveTemplateInstance < 0 THEN tpl:ToQueuePosit:%ActiveTemplateInstance = RECORDS(%BrowseFrom).

IF tpl:ToQueuePosit:%ActiveTemplateInstance > 0 AND tpl:ToQueuePosit:%ActiveTemplateInstance <> tpl:FromQueuePosit:%ActiveTemplateInstance
    tpl:FromSysID:%ActiveTemplateInstance=%TheField
    %TheField= tpl:BigLONG:%ActiveTemplateInstance
    PUT(%TheFile)
    IF tpl:ToQueuePosit:%ActiveTemplateInstance > tpl:FromQueuePosit:%ActiveTemplateInstance
        tpl:Delta:%ActiveTemplateInstance = 1
    ELSE
        tpl:Delta:%ActiveTemplateInstance = -1
    END
    LOOP i# = (tpl:FromQueuePosit:%ActiveTemplateInstance+tpl:Delta:%ActiveTemplateInstance) TO  tpl:ToQueuePosit:%ActiveTemplateInstance BY tpl:Delta:%ActiveTemplateInstance
        GET(%BrowseFrom,i#) 
        %TheField = %BrowseFrom.%BrowseObject::%TheField
        GET(%TheFile,%TheKey)
        tpl:TempSysID:%ActiveTemplateInstance = %TheField
        %TheField = tpl:FromSysID:%ActiveTemplateInstance
        PUT(%TheFile)
        tpl:FromSysID:%ActiveTemplateInstance = tpl:TempSysID:%ActiveTemplateInstance
    END
    %TheField = tpl:BigLONG:%ActiveTemplateInstance
    GET(%TheFile,%TheKey)
    %TheField=tpl:FromSysID:%ActiveTemplateInstance
    PUT(%TheFile)
ELSE
END
%BrowseObject::LocateMode = LocateOnEdit
DO %BrowseObject::LocateRecord
DO %BrowseObject::InitializeBrowse
DO %BrowseObject::PostNewSelection
SELECT(%BrowseUse)
#ENDAT
#AT(%AcceptLoopAfterEventHandling)
#IF(%Condition)
    IF %Condition
        %BrowseUse{PROP:DROPID} = tpl:Identifier:%ActiveTemplateInstance
        %BrowseUse{PROP:DRAGID} = tpl:Identifier:%ActiveTemplateInstance
    ELSE
        %BrowseUse{PROP:DROPID} = ''
        %BrowseUse{PROP:DRAGID} = ''
    END
#ENDIF
#ENDAT


